/***************************************************************************
                          codegenerator.h  -  description
                             -------------------
    begin                : mer dc 21 2005
    copyright            : (C) 2005 by Gibaud Alain
    email                : alain.gibaud@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CODEGENERATOR_H
#define CODEGENERATOR_H

#include "device.h"
#include <vector>

using namespace std ;
/**
  *@author Gibaud Alain
  */

class codeGenerator
{
public:
  device *dev ;
public: 
	codeGenerator(device *d);
	~codeGenerator();
  /** No descriptions */
  string processConfigBits(int core, const string& configWordName, int offset=0);
  /** search for a device data record containing a specific key=value parameter */
  static deviceData * find(vector<deviceData *>& vec, const string & key, const string& value);
  /** No descriptions */
  string makeBitsDescription(vector<deviceData *>& bits, int hibit, int lobit);
  /** No descriptions */
  string processConfigRegs();
  /** Remove or substitute delimters used by PiKdev config bits interpretor */
  void noSpuriousChars(string& s);
  /** No descriptions */
  string processAdresses();
  /** No descriptions */
  string processID();
  /** No descriptions */
  string parseBuffersSize();
  /** No descriptions */
  void maskWarning(unsigned int m);
  /** Analyse masks for non contiguous field detection
and split relevants fields to several compacts sub-fields
 */
  void splitNonContiguous( vector<deviceData *>& fields);
  /** Create a vector of compact masks from non compact one. */
  vector<unsigned int> subMasks(unsigned int mask);
};

#endif
