/***************************************************************************
                          device.cpp  -  description
                             -------------------
    begin                : mar dc 20 2005
    copyright            : (C) 2005 by Gibaud Alain
    email                : alain.gibaud@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "device.h"

#include <iostream>
using namespace std ;

device::device(){
}
device::~device()
{
  for(vector<deviceData *>::iterator i=data.begin() ; i != data.end() ; ++i)
  {
    delete (*i) ;
  }
}
/** No descriptions */
ostream& device::print(ostream& os)
{
  os << "Device name : " << name << endl ;
  vector<deviceData *>::iterator i ;
  for( i = data.begin() ; i != data.end() ; ++i)
    (*i)->print(os) ;

  return os ;
}
/** No descriptions */
string device::gpasmName()
{
  string gpname="p" ;
  unsigned int i ;

  for(i= 0 ;i< name.size() && !isdigit(name[i]) ; ++i) ;
  for( ; i< name.size() ; ++i) gpname += tolower(name[i]) ;
 
  return gpname ;
}


/** No descriptions */
int device::deviceCore()
{
  string family ;
  string techno ;
  string model ;
  int r ;
  unsigned int i ;
  
  for(i= 0 ; !isdigit(name[i]) ; ++i) ;  // skip PIC prefix
  for(  ; i < name.size() &&  isdigit(name[i]) ; ++i) family += name[i];
  for(  ; i < name.size() &&  !isdigit(name[i]) ; ++i)  techno += tolower( name[i]) ;
  for(  ; i < name.size() &&  isdigit(name[i]) ; ++i) model += name[i];


  if( family == "10" )
    r = 12 ;
  else if (family == "12")
  {
    if( name == "PIC12F508" || name == "PIC12F509" || name == "PIC12F510" )
      r = 12 ;  // these are special cases,
    else if( techno == "f"  || techno == "hv" ||  techno == "lf" ) 
      r = 14 ;  // modern 12F
    else if( name == "PIC12C671" || name == "PIC12C672" || name == "PIC12CE673" || name == "PIC12CE674" )
      r = 14 ; // modern 12C
    else
      r = 12 ;  // old 12C
  }
  else if( family == "16") 
    r = 14 ;
  else if( family == "18" || family == "30" || family == "24" )
    r = 16 ;
 else r = 0 ; // should not occur

  return r ;
}
