/***************************************************************************
                          devicedata.cpp  -  description
                             -------------------
    begin                : mar dc 20 2005
    copyright            : (C) 2005 by Gibaud Alain
    email                : alain.gibaud@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "devicedata.h"
#include <iostream>

using namespace std ;

deviceData::deviceData(const string& name) : dataname(name)
{
}

deviceData::~deviceData()
{
  for(vector<deviceData *>::iterator i = subdata.begin() ; i != subdata.end() ; ++i)
    delete *i;
}
/** No descriptions */
ostream& deviceData::print(ostream& os)
{
  os << dataname << " "  ;
  os << '(' ;
  map<string, string>::iterator i ;
  for( i = params.begin() ; i != params.end() ; ++i)
  {
     cout << (*i).first << "=" << (*i).second << ' ' ;
  }
  os << ')' << endl ;

  for(vector<deviceData *>::iterator k = subdata.begin() ; k != subdata.end() ; ++k)
    (*k)->print(os) ;

  return os ;
  
}
/** No descriptions */
deviceData::deviceData(const deviceData& d)
{
  dataname = d.dataname ;
  params = d.params ;
  for( unsigned int i = 0 ; i < d.subdata.size() ; ++i)
    subdata.push_back(new deviceData(*(d.subdata[i]))) ;
}
