/***************************************************************************
                          deviceparser.h  -  description
                             -------------------
    begin                : mar dc 20 2005
    copyright            : (C) 2005 by Gibaud Alain
    email                : alain.gibaud@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef DEVICEPARSER_H
#define DEVICEPARSER_H


#include "device.h"

#include <string>
#include <iostream>
#include <fstream>
#include <stack>
#include <vector>

using namespace std ;

/**
  *@author Gibaud Alain
  */

class deviceParser
{
  string      filename ;
  ifstream    stream ;
  device      *dev ;
  string      buffer ;
  unsigned int         kbuffer ;
  int         line_number;
  bool        verbose ;
  /**  */
  stack< vector<deviceData*>* > dds;
public: 
	deviceParser(device *, bool verbose);
	~deviceParser();
  string parseDevice(const string& filename);
  /** No descriptions */
  bool getLine();
  /** No descriptions */
  bool getDeviceName(string& name);
  /** No descriptions */
  bool match(const string& id);
  /** No descriptions */
  bool skipWS();
  /** No descriptions */
  bool ident(string& id);
  /** No descriptions */
  string parseAllEntries(vector<deviceData*>& data);
  /** No descriptions */
  char ch();
  /** get next char. Return 0 if empty buffer
 */
  char gch();
  /** True if we are at Begin Of Line */
  bool BOL();
  /** search for series of 4 white-spaces.
ie: 0, 4, 8, ..., 4*k white-spaces

return true if such a serie is found, and update k accordingly.
 */
  bool levelPrefix(int& k);
  /** try to move cursor backward to n chars
 */
  bool pushBack(unsigned int n);
  /** No descriptions */
  string parseNewData(vector<deviceData*>&  data);
  /** Parse a serie of comma separated  'parameter=value' pairs. */
  /** return current line number as a string */
  string ln();
  string parseParameters(map<string, string>& table);
  /** No descriptions */
  string parseUniqueParameter(map<string, string>& table);
  /** No descriptions */
  string parseUniqueRange(map<string, string>& table);
  /** No descriptions */
  bool isComment();
  /** true if line contains only blanks or tabs before newline */
  bool isBlank();
};

#endif
