/***************************************************************************
                          utils.cpp  -  description
                             -------------------
    begin                : jeu d�c 22 2005
    copyright            : (C) 2005 by Gibaud Alain
    email                : alain.gibaud@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "utils.h"
#include <cstdio>
#include <vector>
using namespace std ;

bool utils::toInt(const string& s, int& k)
{
  k = 0 ;
  if( sscanf(s.c_str(), "0x%x", (unsigned  int*)&k) ==1)
    return true ;
  else if( sscanf(s.c_str(), "0X%x", (unsigned  int*)&k) == 1)
    return true ;
  else if( sscanf(s.c_str(), "%d", &k) == 1)
    return true ;

  return false ;
  
}

bool utils::maskComparator( deviceData *a1, deviceData *a2)
{
  string m1 = a1->params["mask"] ;
  string m2 = a2->params["mask"] ;
  unsigned int i1 , i2 ;
  utils::toUInt(m1,i1) ;
  utils::toUInt(m2,i2) ;
  return i1 > i2 ;
}

/** No descriptions */
bool utils::maskToRange(unsigned int mask, int& bh, int& bl)
{
  if(mask == 0 ) return false ;

  for( bl = 0 , bh = -1; !(mask & 1) ; mask >>= 1)
  {
    ++bl ; ++bh ;
  }

  for( ; mask ; mask >>= 1) ++bh ;

  return true ;  
}
/** No descriptions */
bool utils::toUInt(const string & s, unsigned int & k)
{
  k = 0 ;
  if( sscanf(s.c_str(), "0x%x", &k) ==1)
    return true ;
  else if( sscanf(s.c_str(), "0X%x", &k) == 1)
    return true ;
  else if( sscanf(s.c_str(), "%u", &k) == 1)
    return true ;

  return false ;

}  


vector<deviceData *> utils::filter(vector<deviceData *>& vec, const string& name)
{
     vector<deviceData *>::iterator i ;
     vector<deviceData *> r ;
     for( i = vec.begin() ; i != vec.end() ; ++i)
      if( (*i)->dataname == name) r.push_back(*i) ;
     return r ;
}

vector<deviceData *> utils::filter(vector<deviceData *>& vec, const string& key, const string& value)
{
     vector<deviceData *>::iterator i ;
     vector<deviceData *> r ;
     for( i = vec.begin() ; i != vec.end() ; ++i)
     {
        map<string, string>& p = (*i)->params ;
        map<string, string>::iterator k = p.find(key) ;
        if( k != p.end() && (*k).second == value)  r.push_back(*i) ;
     }
     return r ;
}
/** No descriptions */
string utils::bitsToString(unsigned int k, int bh, int bl)
{
  string r ;
  for(int i = bh ; i >= bl ; --i)
  {
    r += (k & (1 << i)) ? '1' : '0' ;
  }
  return r ;
}
/** No descriptions */
void utils::splitRegion(const string& region, string& lo, string& hi)
{
  lo.clear() ;
  hi.clear() ;
  unsigned int i ;
  for(i = 0 ; i < region.size() && region[i] != '-' ; ++i)
    lo += region[i] ;
  for( ++i ; i < region.size()   ; ++i)
    hi += region[i] ;
}
/** No descriptions */
string utils::gpasmName(const string& name)
{
  string gpname="p" ;
  unsigned int i ;

  for(i= 0 ;i< name.size() && !isdigit(name[i]) ; ++i) ;
  for( ; i< name.size() ; ++i) gpname += tolower(name[i]) ;

  return gpname ;
}
/** Dectect the state of bits in a range bl-bh of mask
Return:
- '0' => all 0
- '1' => all 1
- 'X' => mixed
 */
char utils::bitState(int bl, int bh, unsigned int mask)
{
  char r=' ' ;
  if( bl > bh )
  {
    int t= bl ; bl = bh ; bh = t ;
  }

  for(int i = bl ; i <= bh ; ++i)
  {
    if( mask & (1<<i))
    {  // bit is 1
      if(r == '0') r = 'X' ;
      else if(r == ' ') r = '1' ;
    }
    else
    {
        if(r == '1') r = 'X' ;
        else if(r == ' ') r = '0' ;
    }  
  }
  return r ;
}
