/***************************************************************************
                          utils.h  -  description
                             -------------------
    begin                : jeu d�c 22 2005
    copyright            : (C) 2005 by Gibaud Alain
    email                : alain.gibaud@free.fr
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTILS_H
#define UTILS_H
#include "devicedata.h"
#include <string>
using namespace std ;

/**Variour utility functions

  *@author Gibaud Alain
  */

class utils
{
public:
  static bool toInt(const string& s, int& k) ; 
  static bool toUInt(const string & s, unsigned int& k);
  static bool maskComparator( deviceData *a1, deviceData *a2) ;
  static bool maskToRange(unsigned int mask, int& bh, int& bl);
  static vector<deviceData *> filter(vector<deviceData *>& vec, const string& name);
  static vector<deviceData *> filter(vector<deviceData *>& vec, const string& key,const string& value );
  /** No descriptions */
  static string bitsToString(unsigned int k, int bh, int bl);
  /** No descriptions */
  static void splitRegion(const string& region, string& lo, string& hi);
  /** No descriptions */
  static string gpasmName(const string& name);
  /** Dectect the state of bits in a range bl-bh of mask
Return:
- '0' => all 0
- '1' => all 1
- 'X' => mixed
 */
  static char bitState(int bl, int bh, unsigned int mask);
} ;
#endif
